// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_msgs:msg/AccessPoint.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__ACCESS_POINT__BUILDER_HPP_
#define COB_MSGS__MSG__DETAIL__ACCESS_POINT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_msgs/msg/detail/access_point__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_msgs
{

namespace msg
{

namespace builder
{

class Init_AccessPoint_quality
{
public:
  explicit Init_AccessPoint_quality(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  ::cob_msgs::msg::AccessPoint quality(::cob_msgs::msg::AccessPoint::_quality_type arg)
  {
    msg_.quality = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_tx_power
{
public:
  explicit Init_AccessPoint_tx_power(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_quality tx_power(::cob_msgs::msg::AccessPoint::_tx_power_type arg)
  {
    msg_.tx_power = std::move(arg);
    return Init_AccessPoint_quality(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_rate
{
public:
  explicit Init_AccessPoint_rate(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_tx_power rate(::cob_msgs::msg::AccessPoint::_rate_type arg)
  {
    msg_.rate = std::move(arg);
    return Init_AccessPoint_tx_power(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_channel
{
public:
  explicit Init_AccessPoint_channel(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_rate channel(::cob_msgs::msg::AccessPoint::_channel_type arg)
  {
    msg_.channel = std::move(arg);
    return Init_AccessPoint_rate(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_snr
{
public:
  explicit Init_AccessPoint_snr(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_channel snr(::cob_msgs::msg::AccessPoint::_snr_type arg)
  {
    msg_.snr = std::move(arg);
    return Init_AccessPoint_channel(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_noise
{
public:
  explicit Init_AccessPoint_noise(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_snr noise(::cob_msgs::msg::AccessPoint::_noise_type arg)
  {
    msg_.noise = std::move(arg);
    return Init_AccessPoint_snr(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_signal
{
public:
  explicit Init_AccessPoint_signal(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_noise signal(::cob_msgs::msg::AccessPoint::_signal_type arg)
  {
    msg_.signal = std::move(arg);
    return Init_AccessPoint_noise(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_macaddr
{
public:
  explicit Init_AccessPoint_macaddr(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_signal macaddr(::cob_msgs::msg::AccessPoint::_macaddr_type arg)
  {
    msg_.macaddr = std::move(arg);
    return Init_AccessPoint_signal(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_essid
{
public:
  explicit Init_AccessPoint_essid(::cob_msgs::msg::AccessPoint & msg)
  : msg_(msg)
  {}
  Init_AccessPoint_macaddr essid(::cob_msgs::msg::AccessPoint::_essid_type arg)
  {
    msg_.essid = std::move(arg);
    return Init_AccessPoint_macaddr(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

class Init_AccessPoint_header
{
public:
  Init_AccessPoint_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_AccessPoint_essid header(::cob_msgs::msg::AccessPoint::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_AccessPoint_essid(msg_);
  }

private:
  ::cob_msgs::msg::AccessPoint msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_msgs::msg::AccessPoint>()
{
  return cob_msgs::msg::builder::Init_AccessPoint_header();
}

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__ACCESS_POINT__BUILDER_HPP_
