// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from cob_msgs:msg/AccessPoint.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_H_
#define COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'essid'
// Member 'macaddr'
// Member 'rate'
// Member 'tx_power'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/AccessPoint in the package cob_msgs.
/**
  * This message communicates the state of the PR2's wifi access point.
 */
typedef struct cob_msgs__msg__AccessPoint
{
  std_msgs__msg__Header header;
  rosidl_runtime_c__String essid;
  rosidl_runtime_c__String macaddr;
  int32_t signal;
  int32_t noise;
  int32_t snr;
  int32_t channel;
  rosidl_runtime_c__String rate;
  rosidl_runtime_c__String tx_power;
  int32_t quality;
} cob_msgs__msg__AccessPoint;

// Struct for a sequence of cob_msgs__msg__AccessPoint.
typedef struct cob_msgs__msg__AccessPoint__Sequence
{
  cob_msgs__msg__AccessPoint * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} cob_msgs__msg__AccessPoint__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_H_
