// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/AccessPoint.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__AccessPoint __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__AccessPoint __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AccessPoint_
{
  using Type = AccessPoint_<ContainerAllocator>;

  explicit AccessPoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->essid = "";
      this->macaddr = "";
      this->signal = 0l;
      this->noise = 0l;
      this->snr = 0l;
      this->channel = 0l;
      this->rate = "";
      this->tx_power = "";
      this->quality = 0l;
    }
  }

  explicit AccessPoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    essid(_alloc),
    macaddr(_alloc),
    rate(_alloc),
    tx_power(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->essid = "";
      this->macaddr = "";
      this->signal = 0l;
      this->noise = 0l;
      this->snr = 0l;
      this->channel = 0l;
      this->rate = "";
      this->tx_power = "";
      this->quality = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _essid_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _essid_type essid;
  using _macaddr_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _macaddr_type macaddr;
  using _signal_type =
    int32_t;
  _signal_type signal;
  using _noise_type =
    int32_t;
  _noise_type noise;
  using _snr_type =
    int32_t;
  _snr_type snr;
  using _channel_type =
    int32_t;
  _channel_type channel;
  using _rate_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _rate_type rate;
  using _tx_power_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _tx_power_type tx_power;
  using _quality_type =
    int32_t;
  _quality_type quality;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__essid(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->essid = _arg;
    return *this;
  }
  Type & set__macaddr(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->macaddr = _arg;
    return *this;
  }
  Type & set__signal(
    const int32_t & _arg)
  {
    this->signal = _arg;
    return *this;
  }
  Type & set__noise(
    const int32_t & _arg)
  {
    this->noise = _arg;
    return *this;
  }
  Type & set__snr(
    const int32_t & _arg)
  {
    this->snr = _arg;
    return *this;
  }
  Type & set__channel(
    const int32_t & _arg)
  {
    this->channel = _arg;
    return *this;
  }
  Type & set__rate(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->rate = _arg;
    return *this;
  }
  Type & set__tx_power(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->tx_power = _arg;
    return *this;
  }
  Type & set__quality(
    const int32_t & _arg)
  {
    this->quality = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::AccessPoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::AccessPoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::AccessPoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::AccessPoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__AccessPoint
    std::shared_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__AccessPoint
    std::shared_ptr<cob_msgs::msg::AccessPoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AccessPoint_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->essid != other.essid) {
      return false;
    }
    if (this->macaddr != other.macaddr) {
      return false;
    }
    if (this->signal != other.signal) {
      return false;
    }
    if (this->noise != other.noise) {
      return false;
    }
    if (this->snr != other.snr) {
      return false;
    }
    if (this->channel != other.channel) {
      return false;
    }
    if (this->rate != other.rate) {
      return false;
    }
    if (this->tx_power != other.tx_power) {
      return false;
    }
    if (this->quality != other.quality) {
      return false;
    }
    return true;
  }
  bool operator!=(const AccessPoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AccessPoint_

// alias to use template instance with default allocator
using AccessPoint =
  cob_msgs::msg::AccessPoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__ACCESS_POINT__STRUCT_HPP_
