// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/DashboardState.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/dashboard_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `diagnostics_toplevel_state`
#include "diagnostic_msgs/msg/detail/diagnostic_status__functions.h"
// Member `power_state`
#include "cob_msgs/msg/detail/power_state__functions.h"
// Member `emergency_stop_state`
#include "cob_msgs/msg/detail/emergency_stop_state__functions.h"

bool
cob_msgs__msg__DashboardState__init(cob_msgs__msg__DashboardState * msg)
{
  if (!msg) {
    return false;
  }
  // diagnostics_toplevel_state
  if (!diagnostic_msgs__msg__DiagnosticStatus__init(&msg->diagnostics_toplevel_state)) {
    cob_msgs__msg__DashboardState__fini(msg);
    return false;
  }
  // power_state
  if (!cob_msgs__msg__PowerState__init(&msg->power_state)) {
    cob_msgs__msg__DashboardState__fini(msg);
    return false;
  }
  // emergency_stop_state
  if (!cob_msgs__msg__EmergencyStopState__init(&msg->emergency_stop_state)) {
    cob_msgs__msg__DashboardState__fini(msg);
    return false;
  }
  return true;
}

void
cob_msgs__msg__DashboardState__fini(cob_msgs__msg__DashboardState * msg)
{
  if (!msg) {
    return;
  }
  // diagnostics_toplevel_state
  diagnostic_msgs__msg__DiagnosticStatus__fini(&msg->diagnostics_toplevel_state);
  // power_state
  cob_msgs__msg__PowerState__fini(&msg->power_state);
  // emergency_stop_state
  cob_msgs__msg__EmergencyStopState__fini(&msg->emergency_stop_state);
}

bool
cob_msgs__msg__DashboardState__are_equal(const cob_msgs__msg__DashboardState * lhs, const cob_msgs__msg__DashboardState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // diagnostics_toplevel_state
  if (!diagnostic_msgs__msg__DiagnosticStatus__are_equal(
      &(lhs->diagnostics_toplevel_state), &(rhs->diagnostics_toplevel_state)))
  {
    return false;
  }
  // power_state
  if (!cob_msgs__msg__PowerState__are_equal(
      &(lhs->power_state), &(rhs->power_state)))
  {
    return false;
  }
  // emergency_stop_state
  if (!cob_msgs__msg__EmergencyStopState__are_equal(
      &(lhs->emergency_stop_state), &(rhs->emergency_stop_state)))
  {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__DashboardState__copy(
  const cob_msgs__msg__DashboardState * input,
  cob_msgs__msg__DashboardState * output)
{
  if (!input || !output) {
    return false;
  }
  // diagnostics_toplevel_state
  if (!diagnostic_msgs__msg__DiagnosticStatus__copy(
      &(input->diagnostics_toplevel_state), &(output->diagnostics_toplevel_state)))
  {
    return false;
  }
  // power_state
  if (!cob_msgs__msg__PowerState__copy(
      &(input->power_state), &(output->power_state)))
  {
    return false;
  }
  // emergency_stop_state
  if (!cob_msgs__msg__EmergencyStopState__copy(
      &(input->emergency_stop_state), &(output->emergency_stop_state)))
  {
    return false;
  }
  return true;
}

cob_msgs__msg__DashboardState *
cob_msgs__msg__DashboardState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__DashboardState * msg = (cob_msgs__msg__DashboardState *)allocator.allocate(sizeof(cob_msgs__msg__DashboardState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__DashboardState));
  bool success = cob_msgs__msg__DashboardState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__DashboardState__destroy(cob_msgs__msg__DashboardState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__DashboardState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__DashboardState__Sequence__init(cob_msgs__msg__DashboardState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__DashboardState * data = NULL;

  if (size) {
    data = (cob_msgs__msg__DashboardState *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__DashboardState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__DashboardState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__DashboardState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__DashboardState__Sequence__fini(cob_msgs__msg__DashboardState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__DashboardState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__DashboardState__Sequence *
cob_msgs__msg__DashboardState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__DashboardState__Sequence * array = (cob_msgs__msg__DashboardState__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__DashboardState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__DashboardState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__DashboardState__Sequence__destroy(cob_msgs__msg__DashboardState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__DashboardState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__DashboardState__Sequence__are_equal(const cob_msgs__msg__DashboardState__Sequence * lhs, const cob_msgs__msg__DashboardState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__DashboardState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__DashboardState__Sequence__copy(
  const cob_msgs__msg__DashboardState__Sequence * input,
  cob_msgs__msg__DashboardState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__DashboardState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__DashboardState * data =
      (cob_msgs__msg__DashboardState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__DashboardState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__DashboardState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__DashboardState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
