// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from cob_msgs:msg/DashboardState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__FUNCTIONS_H_
#define COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "cob_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "cob_msgs/msg/detail/dashboard_state__struct.h"

/// Initialize msg/DashboardState message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * cob_msgs__msg__DashboardState
 * )) before or use
 * cob_msgs__msg__DashboardState__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__init(cob_msgs__msg__DashboardState * msg);

/// Finalize msg/DashboardState message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
void
cob_msgs__msg__DashboardState__fini(cob_msgs__msg__DashboardState * msg);

/// Create msg/DashboardState message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * cob_msgs__msg__DashboardState__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
cob_msgs__msg__DashboardState *
cob_msgs__msg__DashboardState__create();

/// Destroy msg/DashboardState message.
/**
 * It calls
 * cob_msgs__msg__DashboardState__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
void
cob_msgs__msg__DashboardState__destroy(cob_msgs__msg__DashboardState * msg);

/// Check for msg/DashboardState message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__are_equal(const cob_msgs__msg__DashboardState * lhs, const cob_msgs__msg__DashboardState * rhs);

/// Copy a msg/DashboardState message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__copy(
  const cob_msgs__msg__DashboardState * input,
  cob_msgs__msg__DashboardState * output);

/// Initialize array of msg/DashboardState messages.
/**
 * It allocates the memory for the number of elements and calls
 * cob_msgs__msg__DashboardState__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__Sequence__init(cob_msgs__msg__DashboardState__Sequence * array, size_t size);

/// Finalize array of msg/DashboardState messages.
/**
 * It calls
 * cob_msgs__msg__DashboardState__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
void
cob_msgs__msg__DashboardState__Sequence__fini(cob_msgs__msg__DashboardState__Sequence * array);

/// Create array of msg/DashboardState messages.
/**
 * It allocates the memory for the array and calls
 * cob_msgs__msg__DashboardState__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
cob_msgs__msg__DashboardState__Sequence *
cob_msgs__msg__DashboardState__Sequence__create(size_t size);

/// Destroy array of msg/DashboardState messages.
/**
 * It calls
 * cob_msgs__msg__DashboardState__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
void
cob_msgs__msg__DashboardState__Sequence__destroy(cob_msgs__msg__DashboardState__Sequence * array);

/// Check for msg/DashboardState message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__Sequence__are_equal(const cob_msgs__msg__DashboardState__Sequence * lhs, const cob_msgs__msg__DashboardState__Sequence * rhs);

/// Copy an array of msg/DashboardState messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_cob_msgs
bool
cob_msgs__msg__DashboardState__Sequence__copy(
  const cob_msgs__msg__DashboardState__Sequence * input,
  cob_msgs__msg__DashboardState__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__FUNCTIONS_H_
