// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/DashboardState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'diagnostics_toplevel_state'
#include "diagnostic_msgs/msg/detail/diagnostic_status__struct.hpp"
// Member 'power_state'
#include "cob_msgs/msg/detail/power_state__struct.hpp"
// Member 'emergency_stop_state'
#include "cob_msgs/msg/detail/emergency_stop_state__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__DashboardState __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__DashboardState __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DashboardState_
{
  using Type = DashboardState_<ContainerAllocator>;

  explicit DashboardState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : diagnostics_toplevel_state(_init),
    power_state(_init),
    emergency_stop_state(_init)
  {
    (void)_init;
  }

  explicit DashboardState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : diagnostics_toplevel_state(_alloc, _init),
    power_state(_alloc, _init),
    emergency_stop_state(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _diagnostics_toplevel_state_type =
    diagnostic_msgs::msg::DiagnosticStatus_<ContainerAllocator>;
  _diagnostics_toplevel_state_type diagnostics_toplevel_state;
  using _power_state_type =
    cob_msgs::msg::PowerState_<ContainerAllocator>;
  _power_state_type power_state;
  using _emergency_stop_state_type =
    cob_msgs::msg::EmergencyStopState_<ContainerAllocator>;
  _emergency_stop_state_type emergency_stop_state;

  // setters for named parameter idiom
  Type & set__diagnostics_toplevel_state(
    const diagnostic_msgs::msg::DiagnosticStatus_<ContainerAllocator> & _arg)
  {
    this->diagnostics_toplevel_state = _arg;
    return *this;
  }
  Type & set__power_state(
    const cob_msgs::msg::PowerState_<ContainerAllocator> & _arg)
  {
    this->power_state = _arg;
    return *this;
  }
  Type & set__emergency_stop_state(
    const cob_msgs::msg::EmergencyStopState_<ContainerAllocator> & _arg)
  {
    this->emergency_stop_state = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::DashboardState_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::DashboardState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::DashboardState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::DashboardState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__DashboardState
    std::shared_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__DashboardState
    std::shared_ptr<cob_msgs::msg::DashboardState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DashboardState_ & other) const
  {
    if (this->diagnostics_toplevel_state != other.diagnostics_toplevel_state) {
      return false;
    }
    if (this->power_state != other.power_state) {
      return false;
    }
    if (this->emergency_stop_state != other.emergency_stop_state) {
      return false;
    }
    return true;
  }
  bool operator!=(const DashboardState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DashboardState_

// alias to use template instance with default allocator
using DashboardState =
  cob_msgs::msg::DashboardState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__STRUCT_HPP_
