// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/DashboardState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/dashboard_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'diagnostics_toplevel_state'
#include "diagnostic_msgs/msg/detail/diagnostic_status__traits.hpp"
// Member 'power_state'
#include "cob_msgs/msg/detail/power_state__traits.hpp"
// Member 'emergency_stop_state'
#include "cob_msgs/msg/detail/emergency_stop_state__traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DashboardState & msg,
  std::ostream & out)
{
  out << "{";
  // member: diagnostics_toplevel_state
  {
    out << "diagnostics_toplevel_state: ";
    to_flow_style_yaml(msg.diagnostics_toplevel_state, out);
    out << ", ";
  }

  // member: power_state
  {
    out << "power_state: ";
    to_flow_style_yaml(msg.power_state, out);
    out << ", ";
  }

  // member: emergency_stop_state
  {
    out << "emergency_stop_state: ";
    to_flow_style_yaml(msg.emergency_stop_state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DashboardState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: diagnostics_toplevel_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "diagnostics_toplevel_state:\n";
    to_block_style_yaml(msg.diagnostics_toplevel_state, out, indentation + 2);
  }

  // member: power_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_state:\n";
    to_block_style_yaml(msg.power_state, out, indentation + 2);
  }

  // member: emergency_stop_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_stop_state:\n";
    to_block_style_yaml(msg.emergency_stop_state, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DashboardState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::DashboardState & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::DashboardState & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::DashboardState>()
{
  return "cob_msgs::msg::DashboardState";
}

template<>
inline const char * name<cob_msgs::msg::DashboardState>()
{
  return "cob_msgs/msg/DashboardState";
}

template<>
struct has_fixed_size<cob_msgs::msg::DashboardState>
  : std::integral_constant<bool, has_fixed_size<cob_msgs::msg::EmergencyStopState>::value && has_fixed_size<cob_msgs::msg::PowerState>::value && has_fixed_size<diagnostic_msgs::msg::DiagnosticStatus>::value> {};

template<>
struct has_bounded_size<cob_msgs::msg::DashboardState>
  : std::integral_constant<bool, has_bounded_size<cob_msgs::msg::EmergencyStopState>::value && has_bounded_size<cob_msgs::msg::PowerState>::value && has_bounded_size<diagnostic_msgs::msg::DiagnosticStatus>::value> {};

template<>
struct is_message<cob_msgs::msg::DashboardState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__DASHBOARD_STATE__TRAITS_HPP_
