// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/EmergencyStopState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/emergency_stop_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EmergencyStopState & msg,
  std::ostream & out)
{
  out << "{";
  // member: emergency_button_stop
  {
    out << "emergency_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_button_stop, out);
    out << ", ";
  }

  // member: scanner_stop
  {
    out << "scanner_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.scanner_stop, out);
    out << ", ";
  }

  // member: monitoring_stop
  {
    out << "monitoring_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.monitoring_stop, out);
    out << ", ";
  }

  // member: user_interaction_stop
  {
    out << "user_interaction_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.user_interaction_stop, out);
    out << ", ";
  }

  // member: hardware_stop
  {
    out << "hardware_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_stop, out);
    out << ", ";
  }

  // member: bumper_stop
  {
    out << "bumper_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.bumper_stop, out);
    out << ", ";
  }

  // member: fall_stop
  {
    out << "fall_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_stop, out);
    out << ", ";
  }

  // member: charge_stop
  {
    out << "charge_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_stop, out);
    out << ", ";
  }

  // member: emergency_state
  {
    out << "emergency_state: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EmergencyStopState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: emergency_button_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_button_stop, out);
    out << "\n";
  }

  // member: scanner_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scanner_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.scanner_stop, out);
    out << "\n";
  }

  // member: monitoring_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "monitoring_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.monitoring_stop, out);
    out << "\n";
  }

  // member: user_interaction_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "user_interaction_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.user_interaction_stop, out);
    out << "\n";
  }

  // member: hardware_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hardware_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.hardware_stop, out);
    out << "\n";
  }

  // member: bumper_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bumper_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.bumper_stop, out);
    out << "\n";
  }

  // member: fall_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_stop, out);
    out << "\n";
  }

  // member: charge_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charge_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.charge_stop, out);
    out << "\n";
  }

  // member: emergency_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_state: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EmergencyStopState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::EmergencyStopState & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::EmergencyStopState & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::EmergencyStopState>()
{
  return "cob_msgs::msg::EmergencyStopState";
}

template<>
inline const char * name<cob_msgs::msg::EmergencyStopState>()
{
  return "cob_msgs/msg/EmergencyStopState";
}

template<>
struct has_fixed_size<cob_msgs::msg::EmergencyStopState>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<cob_msgs::msg::EmergencyStopState>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<cob_msgs::msg::EmergencyStopState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__TRAITS_HPP_
