// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/Network.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__NETWORK__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__NETWORK__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/network__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Network & msg,
  std::ostream & out)
{
  out << "{";
  // member: macattr
  {
    out << "macattr: ";
    rosidl_generator_traits::value_to_yaml(msg.macattr, out);
    out << ", ";
  }

  // member: essid
  {
    out << "essid: ";
    rosidl_generator_traits::value_to_yaml(msg.essid, out);
    out << ", ";
  }

  // member: channel
  {
    out << "channel: ";
    rosidl_generator_traits::value_to_yaml(msg.channel, out);
    out << ", ";
  }

  // member: rssi
  {
    out << "rssi: ";
    rosidl_generator_traits::value_to_yaml(msg.rssi, out);
    out << ", ";
  }

  // member: noise
  {
    out << "noise: ";
    rosidl_generator_traits::value_to_yaml(msg.noise, out);
    out << ", ";
  }

  // member: beacon
  {
    out << "beacon: ";
    rosidl_generator_traits::value_to_yaml(msg.beacon, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Network & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: macattr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "macattr: ";
    rosidl_generator_traits::value_to_yaml(msg.macattr, out);
    out << "\n";
  }

  // member: essid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "essid: ";
    rosidl_generator_traits::value_to_yaml(msg.essid, out);
    out << "\n";
  }

  // member: channel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "channel: ";
    rosidl_generator_traits::value_to_yaml(msg.channel, out);
    out << "\n";
  }

  // member: rssi
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rssi: ";
    rosidl_generator_traits::value_to_yaml(msg.rssi, out);
    out << "\n";
  }

  // member: noise
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "noise: ";
    rosidl_generator_traits::value_to_yaml(msg.noise, out);
    out << "\n";
  }

  // member: beacon
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "beacon: ";
    rosidl_generator_traits::value_to_yaml(msg.beacon, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Network & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::Network & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::Network & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::Network>()
{
  return "cob_msgs::msg::Network";
}

template<>
inline const char * name<cob_msgs::msg::Network>()
{
  return "cob_msgs/msg/Network";
}

template<>
struct has_fixed_size<cob_msgs::msg::Network>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<cob_msgs::msg::Network>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<cob_msgs::msg::Network>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__NETWORK__TRAITS_HPP_
