// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/SafetyControllerState.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/safety_controller_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
cob_msgs__msg__SafetyControllerState__init(cob_msgs__msg__SafetyControllerState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    cob_msgs__msg__SafetyControllerState__fini(msg);
    return false;
  }
  // has_wireless_emstop
  // has_fall_sensors
  // has_magnetic_safety_switch
  // ack_needed
  // emergency_button_stop
  // brake_button_stop
  // laser_stop
  // wireless_stop
  // fall_sensor_stop
  // external_stop
  // laser_bridged
  // wireless_bridged
  // magnetic_safety_switch
  // laser_front_ok
  // laser_left_ok
  // laser_right_ok
  // fall_sensor_front
  // fall_sensor_left
  // fall_sensor_right
  // fall_sensor_released
  // base_active
  // torso_active
  // base_enabled
  // torso_enabled
  return true;
}

void
cob_msgs__msg__SafetyControllerState__fini(cob_msgs__msg__SafetyControllerState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // has_wireless_emstop
  // has_fall_sensors
  // has_magnetic_safety_switch
  // ack_needed
  // emergency_button_stop
  // brake_button_stop
  // laser_stop
  // wireless_stop
  // fall_sensor_stop
  // external_stop
  // laser_bridged
  // wireless_bridged
  // magnetic_safety_switch
  // laser_front_ok
  // laser_left_ok
  // laser_right_ok
  // fall_sensor_front
  // fall_sensor_left
  // fall_sensor_right
  // fall_sensor_released
  // base_active
  // torso_active
  // base_enabled
  // torso_enabled
}

bool
cob_msgs__msg__SafetyControllerState__are_equal(const cob_msgs__msg__SafetyControllerState * lhs, const cob_msgs__msg__SafetyControllerState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // has_wireless_emstop
  if (lhs->has_wireless_emstop != rhs->has_wireless_emstop) {
    return false;
  }
  // has_fall_sensors
  if (lhs->has_fall_sensors != rhs->has_fall_sensors) {
    return false;
  }
  // has_magnetic_safety_switch
  if (lhs->has_magnetic_safety_switch != rhs->has_magnetic_safety_switch) {
    return false;
  }
  // ack_needed
  if (lhs->ack_needed != rhs->ack_needed) {
    return false;
  }
  // emergency_button_stop
  if (lhs->emergency_button_stop != rhs->emergency_button_stop) {
    return false;
  }
  // brake_button_stop
  if (lhs->brake_button_stop != rhs->brake_button_stop) {
    return false;
  }
  // laser_stop
  if (lhs->laser_stop != rhs->laser_stop) {
    return false;
  }
  // wireless_stop
  if (lhs->wireless_stop != rhs->wireless_stop) {
    return false;
  }
  // fall_sensor_stop
  if (lhs->fall_sensor_stop != rhs->fall_sensor_stop) {
    return false;
  }
  // external_stop
  if (lhs->external_stop != rhs->external_stop) {
    return false;
  }
  // laser_bridged
  if (lhs->laser_bridged != rhs->laser_bridged) {
    return false;
  }
  // wireless_bridged
  if (lhs->wireless_bridged != rhs->wireless_bridged) {
    return false;
  }
  // magnetic_safety_switch
  if (lhs->magnetic_safety_switch != rhs->magnetic_safety_switch) {
    return false;
  }
  // laser_front_ok
  if (lhs->laser_front_ok != rhs->laser_front_ok) {
    return false;
  }
  // laser_left_ok
  if (lhs->laser_left_ok != rhs->laser_left_ok) {
    return false;
  }
  // laser_right_ok
  if (lhs->laser_right_ok != rhs->laser_right_ok) {
    return false;
  }
  // fall_sensor_front
  if (lhs->fall_sensor_front != rhs->fall_sensor_front) {
    return false;
  }
  // fall_sensor_left
  if (lhs->fall_sensor_left != rhs->fall_sensor_left) {
    return false;
  }
  // fall_sensor_right
  if (lhs->fall_sensor_right != rhs->fall_sensor_right) {
    return false;
  }
  // fall_sensor_released
  if (lhs->fall_sensor_released != rhs->fall_sensor_released) {
    return false;
  }
  // base_active
  if (lhs->base_active != rhs->base_active) {
    return false;
  }
  // torso_active
  if (lhs->torso_active != rhs->torso_active) {
    return false;
  }
  // base_enabled
  if (lhs->base_enabled != rhs->base_enabled) {
    return false;
  }
  // torso_enabled
  if (lhs->torso_enabled != rhs->torso_enabled) {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__SafetyControllerState__copy(
  const cob_msgs__msg__SafetyControllerState * input,
  cob_msgs__msg__SafetyControllerState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // has_wireless_emstop
  output->has_wireless_emstop = input->has_wireless_emstop;
  // has_fall_sensors
  output->has_fall_sensors = input->has_fall_sensors;
  // has_magnetic_safety_switch
  output->has_magnetic_safety_switch = input->has_magnetic_safety_switch;
  // ack_needed
  output->ack_needed = input->ack_needed;
  // emergency_button_stop
  output->emergency_button_stop = input->emergency_button_stop;
  // brake_button_stop
  output->brake_button_stop = input->brake_button_stop;
  // laser_stop
  output->laser_stop = input->laser_stop;
  // wireless_stop
  output->wireless_stop = input->wireless_stop;
  // fall_sensor_stop
  output->fall_sensor_stop = input->fall_sensor_stop;
  // external_stop
  output->external_stop = input->external_stop;
  // laser_bridged
  output->laser_bridged = input->laser_bridged;
  // wireless_bridged
  output->wireless_bridged = input->wireless_bridged;
  // magnetic_safety_switch
  output->magnetic_safety_switch = input->magnetic_safety_switch;
  // laser_front_ok
  output->laser_front_ok = input->laser_front_ok;
  // laser_left_ok
  output->laser_left_ok = input->laser_left_ok;
  // laser_right_ok
  output->laser_right_ok = input->laser_right_ok;
  // fall_sensor_front
  output->fall_sensor_front = input->fall_sensor_front;
  // fall_sensor_left
  output->fall_sensor_left = input->fall_sensor_left;
  // fall_sensor_right
  output->fall_sensor_right = input->fall_sensor_right;
  // fall_sensor_released
  output->fall_sensor_released = input->fall_sensor_released;
  // base_active
  output->base_active = input->base_active;
  // torso_active
  output->torso_active = input->torso_active;
  // base_enabled
  output->base_enabled = input->base_enabled;
  // torso_enabled
  output->torso_enabled = input->torso_enabled;
  return true;
}

cob_msgs__msg__SafetyControllerState *
cob_msgs__msg__SafetyControllerState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SafetyControllerState * msg = (cob_msgs__msg__SafetyControllerState *)allocator.allocate(sizeof(cob_msgs__msg__SafetyControllerState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__SafetyControllerState));
  bool success = cob_msgs__msg__SafetyControllerState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__SafetyControllerState__destroy(cob_msgs__msg__SafetyControllerState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__SafetyControllerState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__SafetyControllerState__Sequence__init(cob_msgs__msg__SafetyControllerState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SafetyControllerState * data = NULL;

  if (size) {
    data = (cob_msgs__msg__SafetyControllerState *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__SafetyControllerState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__SafetyControllerState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__SafetyControllerState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__SafetyControllerState__Sequence__fini(cob_msgs__msg__SafetyControllerState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__SafetyControllerState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__SafetyControllerState__Sequence *
cob_msgs__msg__SafetyControllerState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SafetyControllerState__Sequence * array = (cob_msgs__msg__SafetyControllerState__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__SafetyControllerState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__SafetyControllerState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__SafetyControllerState__Sequence__destroy(cob_msgs__msg__SafetyControllerState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__SafetyControllerState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__SafetyControllerState__Sequence__are_equal(const cob_msgs__msg__SafetyControllerState__Sequence * lhs, const cob_msgs__msg__SafetyControllerState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__SafetyControllerState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__SafetyControllerState__Sequence__copy(
  const cob_msgs__msg__SafetyControllerState__Sequence * input,
  cob_msgs__msg__SafetyControllerState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__SafetyControllerState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__SafetyControllerState * data =
      (cob_msgs__msg__SafetyControllerState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__SafetyControllerState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__SafetyControllerState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__SafetyControllerState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
