// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/SiteSurvey.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/site_survey__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `networks`
#include "cob_msgs/msg/detail/network__functions.h"

bool
cob_msgs__msg__SiteSurvey__init(cob_msgs__msg__SiteSurvey * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    cob_msgs__msg__SiteSurvey__fini(msg);
    return false;
  }
  // networks
  if (!cob_msgs__msg__Network__Sequence__init(&msg->networks, 0)) {
    cob_msgs__msg__SiteSurvey__fini(msg);
    return false;
  }
  return true;
}

void
cob_msgs__msg__SiteSurvey__fini(cob_msgs__msg__SiteSurvey * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // networks
  cob_msgs__msg__Network__Sequence__fini(&msg->networks);
}

bool
cob_msgs__msg__SiteSurvey__are_equal(const cob_msgs__msg__SiteSurvey * lhs, const cob_msgs__msg__SiteSurvey * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // networks
  if (!cob_msgs__msg__Network__Sequence__are_equal(
      &(lhs->networks), &(rhs->networks)))
  {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__SiteSurvey__copy(
  const cob_msgs__msg__SiteSurvey * input,
  cob_msgs__msg__SiteSurvey * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // networks
  if (!cob_msgs__msg__Network__Sequence__copy(
      &(input->networks), &(output->networks)))
  {
    return false;
  }
  return true;
}

cob_msgs__msg__SiteSurvey *
cob_msgs__msg__SiteSurvey__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SiteSurvey * msg = (cob_msgs__msg__SiteSurvey *)allocator.allocate(sizeof(cob_msgs__msg__SiteSurvey), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__SiteSurvey));
  bool success = cob_msgs__msg__SiteSurvey__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__SiteSurvey__destroy(cob_msgs__msg__SiteSurvey * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__SiteSurvey__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__SiteSurvey__Sequence__init(cob_msgs__msg__SiteSurvey__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SiteSurvey * data = NULL;

  if (size) {
    data = (cob_msgs__msg__SiteSurvey *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__SiteSurvey), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__SiteSurvey__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__SiteSurvey__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__SiteSurvey__Sequence__fini(cob_msgs__msg__SiteSurvey__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__SiteSurvey__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__SiteSurvey__Sequence *
cob_msgs__msg__SiteSurvey__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__SiteSurvey__Sequence * array = (cob_msgs__msg__SiteSurvey__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__SiteSurvey__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__SiteSurvey__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__SiteSurvey__Sequence__destroy(cob_msgs__msg__SiteSurvey__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__SiteSurvey__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__SiteSurvey__Sequence__are_equal(const cob_msgs__msg__SiteSurvey__Sequence * lhs, const cob_msgs__msg__SiteSurvey__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__SiteSurvey__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__SiteSurvey__Sequence__copy(
  const cob_msgs__msg__SiteSurvey__Sequence * input,
  cob_msgs__msg__SiteSurvey__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__SiteSurvey);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__SiteSurvey * data =
      (cob_msgs__msg__SiteSurvey *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__SiteSurvey__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__SiteSurvey__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__SiteSurvey__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
