// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/SiteSurvey.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__SITE_SURVEY__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__SITE_SURVEY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'networks'
#include "cob_msgs/msg/detail/network__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__SiteSurvey __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__SiteSurvey __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SiteSurvey_
{
  using Type = SiteSurvey_<ContainerAllocator>;

  explicit SiteSurvey_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit SiteSurvey_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _networks_type =
    std::vector<cob_msgs::msg::Network_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<cob_msgs::msg::Network_<ContainerAllocator>>>;
  _networks_type networks;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__networks(
    const std::vector<cob_msgs::msg::Network_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<cob_msgs::msg::Network_<ContainerAllocator>>> & _arg)
  {
    this->networks = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::SiteSurvey_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::SiteSurvey_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::SiteSurvey_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::SiteSurvey_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__SiteSurvey
    std::shared_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__SiteSurvey
    std::shared_ptr<cob_msgs::msg::SiteSurvey_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SiteSurvey_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->networks != other.networks) {
      return false;
    }
    return true;
  }
  bool operator!=(const SiteSurvey_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SiteSurvey_

// alias to use template instance with default allocator
using SiteSurvey =
  cob_msgs::msg::SiteSurvey_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__SITE_SURVEY__STRUCT_HPP_
