// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/SiteSurvey.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__SITE_SURVEY__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__SITE_SURVEY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/site_survey__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'networks'
#include "cob_msgs/msg/detail/network__traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SiteSurvey & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: networks
  {
    if (msg.networks.size() == 0) {
      out << "networks: []";
    } else {
      out << "networks: [";
      size_t pending_items = msg.networks.size();
      for (auto item : msg.networks) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SiteSurvey & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: networks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.networks.size() == 0) {
      out << "networks: []\n";
    } else {
      out << "networks:\n";
      for (auto item : msg.networks) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SiteSurvey & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::SiteSurvey & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::SiteSurvey & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::SiteSurvey>()
{
  return "cob_msgs::msg::SiteSurvey";
}

template<>
inline const char * name<cob_msgs::msg::SiteSurvey>()
{
  return "cob_msgs/msg/SiteSurvey";
}

template<>
struct has_fixed_size<cob_msgs::msg::SiteSurvey>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<cob_msgs::msg::SiteSurvey>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<cob_msgs::msg::SiteSurvey>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__SITE_SURVEY__TRAITS_HPP_
