// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/AccessPoint.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/access_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `essid`
// Member `macaddr`
// Member `rate`
// Member `tx_power`
#include "rosidl_runtime_c/string_functions.h"

bool
cob_msgs__msg__AccessPoint__init(cob_msgs__msg__AccessPoint * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    cob_msgs__msg__AccessPoint__fini(msg);
    return false;
  }
  // essid
  if (!rosidl_runtime_c__String__init(&msg->essid)) {
    cob_msgs__msg__AccessPoint__fini(msg);
    return false;
  }
  // macaddr
  if (!rosidl_runtime_c__String__init(&msg->macaddr)) {
    cob_msgs__msg__AccessPoint__fini(msg);
    return false;
  }
  // signal
  // noise
  // snr
  // channel
  // rate
  if (!rosidl_runtime_c__String__init(&msg->rate)) {
    cob_msgs__msg__AccessPoint__fini(msg);
    return false;
  }
  // tx_power
  if (!rosidl_runtime_c__String__init(&msg->tx_power)) {
    cob_msgs__msg__AccessPoint__fini(msg);
    return false;
  }
  // quality
  return true;
}

void
cob_msgs__msg__AccessPoint__fini(cob_msgs__msg__AccessPoint * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // essid
  rosidl_runtime_c__String__fini(&msg->essid);
  // macaddr
  rosidl_runtime_c__String__fini(&msg->macaddr);
  // signal
  // noise
  // snr
  // channel
  // rate
  rosidl_runtime_c__String__fini(&msg->rate);
  // tx_power
  rosidl_runtime_c__String__fini(&msg->tx_power);
  // quality
}

bool
cob_msgs__msg__AccessPoint__are_equal(const cob_msgs__msg__AccessPoint * lhs, const cob_msgs__msg__AccessPoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // essid
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->essid), &(rhs->essid)))
  {
    return false;
  }
  // macaddr
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->macaddr), &(rhs->macaddr)))
  {
    return false;
  }
  // signal
  if (lhs->signal != rhs->signal) {
    return false;
  }
  // noise
  if (lhs->noise != rhs->noise) {
    return false;
  }
  // snr
  if (lhs->snr != rhs->snr) {
    return false;
  }
  // channel
  if (lhs->channel != rhs->channel) {
    return false;
  }
  // rate
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->rate), &(rhs->rate)))
  {
    return false;
  }
  // tx_power
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->tx_power), &(rhs->tx_power)))
  {
    return false;
  }
  // quality
  if (lhs->quality != rhs->quality) {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__AccessPoint__copy(
  const cob_msgs__msg__AccessPoint * input,
  cob_msgs__msg__AccessPoint * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // essid
  if (!rosidl_runtime_c__String__copy(
      &(input->essid), &(output->essid)))
  {
    return false;
  }
  // macaddr
  if (!rosidl_runtime_c__String__copy(
      &(input->macaddr), &(output->macaddr)))
  {
    return false;
  }
  // signal
  output->signal = input->signal;
  // noise
  output->noise = input->noise;
  // snr
  output->snr = input->snr;
  // channel
  output->channel = input->channel;
  // rate
  if (!rosidl_runtime_c__String__copy(
      &(input->rate), &(output->rate)))
  {
    return false;
  }
  // tx_power
  if (!rosidl_runtime_c__String__copy(
      &(input->tx_power), &(output->tx_power)))
  {
    return false;
  }
  // quality
  output->quality = input->quality;
  return true;
}

cob_msgs__msg__AccessPoint *
cob_msgs__msg__AccessPoint__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__AccessPoint * msg = (cob_msgs__msg__AccessPoint *)allocator.allocate(sizeof(cob_msgs__msg__AccessPoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__AccessPoint));
  bool success = cob_msgs__msg__AccessPoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__AccessPoint__destroy(cob_msgs__msg__AccessPoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__AccessPoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__AccessPoint__Sequence__init(cob_msgs__msg__AccessPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__AccessPoint * data = NULL;

  if (size) {
    data = (cob_msgs__msg__AccessPoint *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__AccessPoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__AccessPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__AccessPoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__AccessPoint__Sequence__fini(cob_msgs__msg__AccessPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__AccessPoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__AccessPoint__Sequence *
cob_msgs__msg__AccessPoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__AccessPoint__Sequence * array = (cob_msgs__msg__AccessPoint__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__AccessPoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__AccessPoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__AccessPoint__Sequence__destroy(cob_msgs__msg__AccessPoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__AccessPoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__AccessPoint__Sequence__are_equal(const cob_msgs__msg__AccessPoint__Sequence * lhs, const cob_msgs__msg__AccessPoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__AccessPoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__AccessPoint__Sequence__copy(
  const cob_msgs__msg__AccessPoint__Sequence * input,
  cob_msgs__msg__AccessPoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__AccessPoint);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__AccessPoint * data =
      (cob_msgs__msg__AccessPoint *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__AccessPoint__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__AccessPoint__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__AccessPoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
