// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_msgs:msg/EmergencyStopState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__BUILDER_HPP_
#define COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_msgs/msg/detail/emergency_stop_state__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_msgs
{

namespace msg
{

namespace builder
{

class Init_EmergencyStopState_emergency_state
{
public:
  explicit Init_EmergencyStopState_emergency_state(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  ::cob_msgs::msg::EmergencyStopState emergency_state(::cob_msgs::msg::EmergencyStopState::_emergency_state_type arg)
  {
    msg_.emergency_state = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_charge_stop
{
public:
  explicit Init_EmergencyStopState_charge_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_emergency_state charge_stop(::cob_msgs::msg::EmergencyStopState::_charge_stop_type arg)
  {
    msg_.charge_stop = std::move(arg);
    return Init_EmergencyStopState_emergency_state(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_fall_stop
{
public:
  explicit Init_EmergencyStopState_fall_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_charge_stop fall_stop(::cob_msgs::msg::EmergencyStopState::_fall_stop_type arg)
  {
    msg_.fall_stop = std::move(arg);
    return Init_EmergencyStopState_charge_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_bumper_stop
{
public:
  explicit Init_EmergencyStopState_bumper_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_fall_stop bumper_stop(::cob_msgs::msg::EmergencyStopState::_bumper_stop_type arg)
  {
    msg_.bumper_stop = std::move(arg);
    return Init_EmergencyStopState_fall_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_hardware_stop
{
public:
  explicit Init_EmergencyStopState_hardware_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_bumper_stop hardware_stop(::cob_msgs::msg::EmergencyStopState::_hardware_stop_type arg)
  {
    msg_.hardware_stop = std::move(arg);
    return Init_EmergencyStopState_bumper_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_user_interaction_stop
{
public:
  explicit Init_EmergencyStopState_user_interaction_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_hardware_stop user_interaction_stop(::cob_msgs::msg::EmergencyStopState::_user_interaction_stop_type arg)
  {
    msg_.user_interaction_stop = std::move(arg);
    return Init_EmergencyStopState_hardware_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_monitoring_stop
{
public:
  explicit Init_EmergencyStopState_monitoring_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_user_interaction_stop monitoring_stop(::cob_msgs::msg::EmergencyStopState::_monitoring_stop_type arg)
  {
    msg_.monitoring_stop = std::move(arg);
    return Init_EmergencyStopState_user_interaction_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_scanner_stop
{
public:
  explicit Init_EmergencyStopState_scanner_stop(::cob_msgs::msg::EmergencyStopState & msg)
  : msg_(msg)
  {}
  Init_EmergencyStopState_monitoring_stop scanner_stop(::cob_msgs::msg::EmergencyStopState::_scanner_stop_type arg)
  {
    msg_.scanner_stop = std::move(arg);
    return Init_EmergencyStopState_monitoring_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

class Init_EmergencyStopState_emergency_button_stop
{
public:
  Init_EmergencyStopState_emergency_button_stop()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_EmergencyStopState_scanner_stop emergency_button_stop(::cob_msgs::msg::EmergencyStopState::_emergency_button_stop_type arg)
  {
    msg_.emergency_button_stop = std::move(arg);
    return Init_EmergencyStopState_scanner_stop(msg_);
  }

private:
  ::cob_msgs::msg::EmergencyStopState msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_msgs::msg::EmergencyStopState>()
{
  return cob_msgs::msg::builder::Init_EmergencyStopState_emergency_button_stop();
}

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__BUILDER_HPP_
