// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/EmergencyStopState.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/emergency_stop_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
cob_msgs__msg__EmergencyStopState__init(cob_msgs__msg__EmergencyStopState * msg)
{
  if (!msg) {
    return false;
  }
  // emergency_button_stop
  // scanner_stop
  // monitoring_stop
  // user_interaction_stop
  // hardware_stop
  // bumper_stop
  // fall_stop
  // charge_stop
  // emergency_state
  return true;
}

void
cob_msgs__msg__EmergencyStopState__fini(cob_msgs__msg__EmergencyStopState * msg)
{
  if (!msg) {
    return;
  }
  // emergency_button_stop
  // scanner_stop
  // monitoring_stop
  // user_interaction_stop
  // hardware_stop
  // bumper_stop
  // fall_stop
  // charge_stop
  // emergency_state
}

bool
cob_msgs__msg__EmergencyStopState__are_equal(const cob_msgs__msg__EmergencyStopState * lhs, const cob_msgs__msg__EmergencyStopState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // emergency_button_stop
  if (lhs->emergency_button_stop != rhs->emergency_button_stop) {
    return false;
  }
  // scanner_stop
  if (lhs->scanner_stop != rhs->scanner_stop) {
    return false;
  }
  // monitoring_stop
  if (lhs->monitoring_stop != rhs->monitoring_stop) {
    return false;
  }
  // user_interaction_stop
  if (lhs->user_interaction_stop != rhs->user_interaction_stop) {
    return false;
  }
  // hardware_stop
  if (lhs->hardware_stop != rhs->hardware_stop) {
    return false;
  }
  // bumper_stop
  if (lhs->bumper_stop != rhs->bumper_stop) {
    return false;
  }
  // fall_stop
  if (lhs->fall_stop != rhs->fall_stop) {
    return false;
  }
  // charge_stop
  if (lhs->charge_stop != rhs->charge_stop) {
    return false;
  }
  // emergency_state
  if (lhs->emergency_state != rhs->emergency_state) {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__EmergencyStopState__copy(
  const cob_msgs__msg__EmergencyStopState * input,
  cob_msgs__msg__EmergencyStopState * output)
{
  if (!input || !output) {
    return false;
  }
  // emergency_button_stop
  output->emergency_button_stop = input->emergency_button_stop;
  // scanner_stop
  output->scanner_stop = input->scanner_stop;
  // monitoring_stop
  output->monitoring_stop = input->monitoring_stop;
  // user_interaction_stop
  output->user_interaction_stop = input->user_interaction_stop;
  // hardware_stop
  output->hardware_stop = input->hardware_stop;
  // bumper_stop
  output->bumper_stop = input->bumper_stop;
  // fall_stop
  output->fall_stop = input->fall_stop;
  // charge_stop
  output->charge_stop = input->charge_stop;
  // emergency_state
  output->emergency_state = input->emergency_state;
  return true;
}

cob_msgs__msg__EmergencyStopState *
cob_msgs__msg__EmergencyStopState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__EmergencyStopState * msg = (cob_msgs__msg__EmergencyStopState *)allocator.allocate(sizeof(cob_msgs__msg__EmergencyStopState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__EmergencyStopState));
  bool success = cob_msgs__msg__EmergencyStopState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__EmergencyStopState__destroy(cob_msgs__msg__EmergencyStopState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__EmergencyStopState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__EmergencyStopState__Sequence__init(cob_msgs__msg__EmergencyStopState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__EmergencyStopState * data = NULL;

  if (size) {
    data = (cob_msgs__msg__EmergencyStopState *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__EmergencyStopState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__EmergencyStopState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__EmergencyStopState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__EmergencyStopState__Sequence__fini(cob_msgs__msg__EmergencyStopState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__EmergencyStopState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__EmergencyStopState__Sequence *
cob_msgs__msg__EmergencyStopState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__EmergencyStopState__Sequence * array = (cob_msgs__msg__EmergencyStopState__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__EmergencyStopState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__EmergencyStopState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__EmergencyStopState__Sequence__destroy(cob_msgs__msg__EmergencyStopState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__EmergencyStopState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__EmergencyStopState__Sequence__are_equal(const cob_msgs__msg__EmergencyStopState__Sequence * lhs, const cob_msgs__msg__EmergencyStopState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__EmergencyStopState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__EmergencyStopState__Sequence__copy(
  const cob_msgs__msg__EmergencyStopState__Sequence * input,
  cob_msgs__msg__EmergencyStopState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__EmergencyStopState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__EmergencyStopState * data =
      (cob_msgs__msg__EmergencyStopState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__EmergencyStopState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__EmergencyStopState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__EmergencyStopState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
