// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/EmergencyStopState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__EmergencyStopState __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__EmergencyStopState __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EmergencyStopState_
{
  using Type = EmergencyStopState_<ContainerAllocator>;

  explicit EmergencyStopState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->emergency_button_stop = false;
      this->scanner_stop = false;
      this->monitoring_stop = false;
      this->user_interaction_stop = false;
      this->hardware_stop = false;
      this->bumper_stop = false;
      this->fall_stop = false;
      this->charge_stop = false;
      this->emergency_state = 0;
    }
  }

  explicit EmergencyStopState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->emergency_button_stop = false;
      this->scanner_stop = false;
      this->monitoring_stop = false;
      this->user_interaction_stop = false;
      this->hardware_stop = false;
      this->bumper_stop = false;
      this->fall_stop = false;
      this->charge_stop = false;
      this->emergency_state = 0;
    }
  }

  // field types and members
  using _emergency_button_stop_type =
    bool;
  _emergency_button_stop_type emergency_button_stop;
  using _scanner_stop_type =
    bool;
  _scanner_stop_type scanner_stop;
  using _monitoring_stop_type =
    bool;
  _monitoring_stop_type monitoring_stop;
  using _user_interaction_stop_type =
    bool;
  _user_interaction_stop_type user_interaction_stop;
  using _hardware_stop_type =
    bool;
  _hardware_stop_type hardware_stop;
  using _bumper_stop_type =
    bool;
  _bumper_stop_type bumper_stop;
  using _fall_stop_type =
    bool;
  _fall_stop_type fall_stop;
  using _charge_stop_type =
    bool;
  _charge_stop_type charge_stop;
  using _emergency_state_type =
    int16_t;
  _emergency_state_type emergency_state;

  // setters for named parameter idiom
  Type & set__emergency_button_stop(
    const bool & _arg)
  {
    this->emergency_button_stop = _arg;
    return *this;
  }
  Type & set__scanner_stop(
    const bool & _arg)
  {
    this->scanner_stop = _arg;
    return *this;
  }
  Type & set__monitoring_stop(
    const bool & _arg)
  {
    this->monitoring_stop = _arg;
    return *this;
  }
  Type & set__user_interaction_stop(
    const bool & _arg)
  {
    this->user_interaction_stop = _arg;
    return *this;
  }
  Type & set__hardware_stop(
    const bool & _arg)
  {
    this->hardware_stop = _arg;
    return *this;
  }
  Type & set__bumper_stop(
    const bool & _arg)
  {
    this->bumper_stop = _arg;
    return *this;
  }
  Type & set__fall_stop(
    const bool & _arg)
  {
    this->fall_stop = _arg;
    return *this;
  }
  Type & set__charge_stop(
    const bool & _arg)
  {
    this->charge_stop = _arg;
    return *this;
  }
  Type & set__emergency_state(
    const int16_t & _arg)
  {
    this->emergency_state = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int16_t EMFREE =
    0;
  static constexpr int16_t EMSTOP =
    1;
  static constexpr int16_t EMCONFIRMED =
    2;

  // pointer types
  using RawPtr =
    cob_msgs::msg::EmergencyStopState_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::EmergencyStopState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::EmergencyStopState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::EmergencyStopState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__EmergencyStopState
    std::shared_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__EmergencyStopState
    std::shared_ptr<cob_msgs::msg::EmergencyStopState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EmergencyStopState_ & other) const
  {
    if (this->emergency_button_stop != other.emergency_button_stop) {
      return false;
    }
    if (this->scanner_stop != other.scanner_stop) {
      return false;
    }
    if (this->monitoring_stop != other.monitoring_stop) {
      return false;
    }
    if (this->user_interaction_stop != other.user_interaction_stop) {
      return false;
    }
    if (this->hardware_stop != other.hardware_stop) {
      return false;
    }
    if (this->bumper_stop != other.bumper_stop) {
      return false;
    }
    if (this->fall_stop != other.fall_stop) {
      return false;
    }
    if (this->charge_stop != other.charge_stop) {
      return false;
    }
    if (this->emergency_state != other.emergency_state) {
      return false;
    }
    return true;
  }
  bool operator!=(const EmergencyStopState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EmergencyStopState_

// alias to use template instance with default allocator
using EmergencyStopState =
  cob_msgs::msg::EmergencyStopState_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int16_t EmergencyStopState_<ContainerAllocator>::EMFREE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int16_t EmergencyStopState_<ContainerAllocator>::EMSTOP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int16_t EmergencyStopState_<ContainerAllocator>::EMCONFIRMED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__EMERGENCY_STOP_STATE__STRUCT_HPP_
