// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_msgs:msg/Network.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__NETWORK__BUILDER_HPP_
#define COB_MSGS__MSG__DETAIL__NETWORK__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_msgs/msg/detail/network__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_msgs
{

namespace msg
{

namespace builder
{

class Init_Network_beacon
{
public:
  explicit Init_Network_beacon(::cob_msgs::msg::Network & msg)
  : msg_(msg)
  {}
  ::cob_msgs::msg::Network beacon(::cob_msgs::msg::Network::_beacon_type arg)
  {
    msg_.beacon = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

class Init_Network_noise
{
public:
  explicit Init_Network_noise(::cob_msgs::msg::Network & msg)
  : msg_(msg)
  {}
  Init_Network_beacon noise(::cob_msgs::msg::Network::_noise_type arg)
  {
    msg_.noise = std::move(arg);
    return Init_Network_beacon(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

class Init_Network_rssi
{
public:
  explicit Init_Network_rssi(::cob_msgs::msg::Network & msg)
  : msg_(msg)
  {}
  Init_Network_noise rssi(::cob_msgs::msg::Network::_rssi_type arg)
  {
    msg_.rssi = std::move(arg);
    return Init_Network_noise(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

class Init_Network_channel
{
public:
  explicit Init_Network_channel(::cob_msgs::msg::Network & msg)
  : msg_(msg)
  {}
  Init_Network_rssi channel(::cob_msgs::msg::Network::_channel_type arg)
  {
    msg_.channel = std::move(arg);
    return Init_Network_rssi(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

class Init_Network_essid
{
public:
  explicit Init_Network_essid(::cob_msgs::msg::Network & msg)
  : msg_(msg)
  {}
  Init_Network_channel essid(::cob_msgs::msg::Network::_essid_type arg)
  {
    msg_.essid = std::move(arg);
    return Init_Network_channel(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

class Init_Network_macattr
{
public:
  Init_Network_macattr()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Network_essid macattr(::cob_msgs::msg::Network::_macattr_type arg)
  {
    msg_.macattr = std::move(arg);
    return Init_Network_essid(msg_);
  }

private:
  ::cob_msgs::msg::Network msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_msgs::msg::Network>()
{
  return cob_msgs::msg::builder::Init_Network_macattr();
}

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__NETWORK__BUILDER_HPP_
