// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/Network.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__NETWORK__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__NETWORK__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__Network __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__Network __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Network_
{
  using Type = Network_<ContainerAllocator>;

  explicit Network_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->macattr = "";
      this->essid = "";
      this->channel = 0l;
      this->rssi = 0l;
      this->noise = 0l;
      this->beacon = 0l;
    }
  }

  explicit Network_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : macattr(_alloc),
    essid(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->macattr = "";
      this->essid = "";
      this->channel = 0l;
      this->rssi = 0l;
      this->noise = 0l;
      this->beacon = 0l;
    }
  }

  // field types and members
  using _macattr_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _macattr_type macattr;
  using _essid_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _essid_type essid;
  using _channel_type =
    int32_t;
  _channel_type channel;
  using _rssi_type =
    int32_t;
  _rssi_type rssi;
  using _noise_type =
    int32_t;
  _noise_type noise;
  using _beacon_type =
    int32_t;
  _beacon_type beacon;

  // setters for named parameter idiom
  Type & set__macattr(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->macattr = _arg;
    return *this;
  }
  Type & set__essid(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->essid = _arg;
    return *this;
  }
  Type & set__channel(
    const int32_t & _arg)
  {
    this->channel = _arg;
    return *this;
  }
  Type & set__rssi(
    const int32_t & _arg)
  {
    this->rssi = _arg;
    return *this;
  }
  Type & set__noise(
    const int32_t & _arg)
  {
    this->noise = _arg;
    return *this;
  }
  Type & set__beacon(
    const int32_t & _arg)
  {
    this->beacon = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::Network_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::Network_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::Network_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::Network_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::Network_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::Network_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::Network_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::Network_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::Network_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::Network_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__Network
    std::shared_ptr<cob_msgs::msg::Network_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__Network
    std::shared_ptr<cob_msgs::msg::Network_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Network_ & other) const
  {
    if (this->macattr != other.macattr) {
      return false;
    }
    if (this->essid != other.essid) {
      return false;
    }
    if (this->channel != other.channel) {
      return false;
    }
    if (this->rssi != other.rssi) {
      return false;
    }
    if (this->noise != other.noise) {
      return false;
    }
    if (this->beacon != other.beacon) {
      return false;
    }
    return true;
  }
  bool operator!=(const Network_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Network_

// alias to use template instance with default allocator
using Network =
  cob_msgs::msg::Network_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__NETWORK__STRUCT_HPP_
