// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_msgs:msg/PowerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__POWER_STATE__BUILDER_HPP_
#define COB_MSGS__MSG__DETAIL__POWER_STATE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_msgs/msg/detail/power_state__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_msgs
{

namespace msg
{

namespace builder
{

class Init_PowerState_temperature
{
public:
  explicit Init_PowerState_temperature(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  ::cob_msgs::msg::PowerState temperature(::cob_msgs::msg::PowerState::_temperature_type arg)
  {
    msg_.temperature = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_time_remaining
{
public:
  explicit Init_PowerState_time_remaining(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_temperature time_remaining(::cob_msgs::msg::PowerState::_time_remaining_type arg)
  {
    msg_.time_remaining = std::move(arg);
    return Init_PowerState_temperature(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_charging
{
public:
  explicit Init_PowerState_charging(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_time_remaining charging(::cob_msgs::msg::PowerState::_charging_type arg)
  {
    msg_.charging = std::move(arg);
    return Init_PowerState_time_remaining(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_connected
{
public:
  explicit Init_PowerState_connected(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_charging connected(::cob_msgs::msg::PowerState::_connected_type arg)
  {
    msg_.connected = std::move(arg);
    return Init_PowerState_charging(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_relative_remaining_capacity
{
public:
  explicit Init_PowerState_relative_remaining_capacity(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_connected relative_remaining_capacity(::cob_msgs::msg::PowerState::_relative_remaining_capacity_type arg)
  {
    msg_.relative_remaining_capacity = std::move(arg);
    return Init_PowerState_connected(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_remaining_capacity
{
public:
  explicit Init_PowerState_remaining_capacity(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_relative_remaining_capacity remaining_capacity(::cob_msgs::msg::PowerState::_remaining_capacity_type arg)
  {
    msg_.remaining_capacity = std::move(arg);
    return Init_PowerState_relative_remaining_capacity(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_power_consumption
{
public:
  explicit Init_PowerState_power_consumption(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_remaining_capacity power_consumption(::cob_msgs::msg::PowerState::_power_consumption_type arg)
  {
    msg_.power_consumption = std::move(arg);
    return Init_PowerState_remaining_capacity(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_current
{
public:
  explicit Init_PowerState_current(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_power_consumption current(::cob_msgs::msg::PowerState::_current_type arg)
  {
    msg_.current = std::move(arg);
    return Init_PowerState_power_consumption(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_voltage
{
public:
  explicit Init_PowerState_voltage(::cob_msgs::msg::PowerState & msg)
  : msg_(msg)
  {}
  Init_PowerState_current voltage(::cob_msgs::msg::PowerState::_voltage_type arg)
  {
    msg_.voltage = std::move(arg);
    return Init_PowerState_current(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

class Init_PowerState_header
{
public:
  Init_PowerState_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PowerState_voltage header(::cob_msgs::msg::PowerState::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_PowerState_voltage(msg_);
  }

private:
  ::cob_msgs::msg::PowerState msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_msgs::msg::PowerState>()
{
  return cob_msgs::msg::builder::Init_PowerState_header();
}

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__POWER_STATE__BUILDER_HPP_
