// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from cob_msgs:msg/PowerState.idl
// generated code does not contain a copyright notice
#include "cob_msgs/msg/detail/power_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
cob_msgs__msg__PowerState__init(cob_msgs__msg__PowerState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    cob_msgs__msg__PowerState__fini(msg);
    return false;
  }
  // voltage
  // current
  // power_consumption
  // remaining_capacity
  // relative_remaining_capacity
  // connected
  // charging
  // time_remaining
  // temperature
  return true;
}

void
cob_msgs__msg__PowerState__fini(cob_msgs__msg__PowerState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // voltage
  // current
  // power_consumption
  // remaining_capacity
  // relative_remaining_capacity
  // connected
  // charging
  // time_remaining
  // temperature
}

bool
cob_msgs__msg__PowerState__are_equal(const cob_msgs__msg__PowerState * lhs, const cob_msgs__msg__PowerState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // voltage
  if (lhs->voltage != rhs->voltage) {
    return false;
  }
  // current
  if (lhs->current != rhs->current) {
    return false;
  }
  // power_consumption
  if (lhs->power_consumption != rhs->power_consumption) {
    return false;
  }
  // remaining_capacity
  if (lhs->remaining_capacity != rhs->remaining_capacity) {
    return false;
  }
  // relative_remaining_capacity
  if (lhs->relative_remaining_capacity != rhs->relative_remaining_capacity) {
    return false;
  }
  // connected
  if (lhs->connected != rhs->connected) {
    return false;
  }
  // charging
  if (lhs->charging != rhs->charging) {
    return false;
  }
  // time_remaining
  if (lhs->time_remaining != rhs->time_remaining) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  return true;
}

bool
cob_msgs__msg__PowerState__copy(
  const cob_msgs__msg__PowerState * input,
  cob_msgs__msg__PowerState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // voltage
  output->voltage = input->voltage;
  // current
  output->current = input->current;
  // power_consumption
  output->power_consumption = input->power_consumption;
  // remaining_capacity
  output->remaining_capacity = input->remaining_capacity;
  // relative_remaining_capacity
  output->relative_remaining_capacity = input->relative_remaining_capacity;
  // connected
  output->connected = input->connected;
  // charging
  output->charging = input->charging;
  // time_remaining
  output->time_remaining = input->time_remaining;
  // temperature
  output->temperature = input->temperature;
  return true;
}

cob_msgs__msg__PowerState *
cob_msgs__msg__PowerState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__PowerState * msg = (cob_msgs__msg__PowerState *)allocator.allocate(sizeof(cob_msgs__msg__PowerState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(cob_msgs__msg__PowerState));
  bool success = cob_msgs__msg__PowerState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
cob_msgs__msg__PowerState__destroy(cob_msgs__msg__PowerState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    cob_msgs__msg__PowerState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
cob_msgs__msg__PowerState__Sequence__init(cob_msgs__msg__PowerState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__PowerState * data = NULL;

  if (size) {
    data = (cob_msgs__msg__PowerState *)allocator.zero_allocate(size, sizeof(cob_msgs__msg__PowerState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = cob_msgs__msg__PowerState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        cob_msgs__msg__PowerState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
cob_msgs__msg__PowerState__Sequence__fini(cob_msgs__msg__PowerState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      cob_msgs__msg__PowerState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

cob_msgs__msg__PowerState__Sequence *
cob_msgs__msg__PowerState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  cob_msgs__msg__PowerState__Sequence * array = (cob_msgs__msg__PowerState__Sequence *)allocator.allocate(sizeof(cob_msgs__msg__PowerState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = cob_msgs__msg__PowerState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
cob_msgs__msg__PowerState__Sequence__destroy(cob_msgs__msg__PowerState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    cob_msgs__msg__PowerState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
cob_msgs__msg__PowerState__Sequence__are_equal(const cob_msgs__msg__PowerState__Sequence * lhs, const cob_msgs__msg__PowerState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!cob_msgs__msg__PowerState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
cob_msgs__msg__PowerState__Sequence__copy(
  const cob_msgs__msg__PowerState__Sequence * input,
  cob_msgs__msg__PowerState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(cob_msgs__msg__PowerState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    cob_msgs__msg__PowerState * data =
      (cob_msgs__msg__PowerState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!cob_msgs__msg__PowerState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          cob_msgs__msg__PowerState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!cob_msgs__msg__PowerState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
