// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from cob_msgs:msg/PowerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_H_
#define COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/PowerState in the package cob_msgs.
/**
  * This message communicates the state of the power system.
 */
typedef struct cob_msgs__msg__PowerState
{
  std_msgs__msg__Header header;
  double voltage;
  double current;
  /// can only be calculated if not charging
  double power_consumption;
  double remaining_capacity;
  /// percent of maximum capacity (parameter max_capacity)
  double relative_remaining_capacity;
  /// flag if robot is connected to external power or not (charging station or external charger)
  bool connected;
  /// flag if robot is charging (energy flow into battery)
  bool charging;
  /// estimated time to empty or fully charged
  double time_remaining;
  /// temperature of the battery
  double temperature;
} cob_msgs__msg__PowerState;

// Struct for a sequence of cob_msgs__msg__PowerState.
typedef struct cob_msgs__msg__PowerState__Sequence
{
  cob_msgs__msg__PowerState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} cob_msgs__msg__PowerState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_H_
