// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/PowerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__PowerState __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__PowerState __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PowerState_
{
  using Type = PowerState_<ContainerAllocator>;

  explicit PowerState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->voltage = 0.0;
      this->current = 0.0;
      this->power_consumption = 0.0;
      this->remaining_capacity = 0.0;
      this->relative_remaining_capacity = 0.0;
      this->connected = false;
      this->charging = false;
      this->time_remaining = 0.0;
      this->temperature = 0.0;
    }
  }

  explicit PowerState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->voltage = 0.0;
      this->current = 0.0;
      this->power_consumption = 0.0;
      this->remaining_capacity = 0.0;
      this->relative_remaining_capacity = 0.0;
      this->connected = false;
      this->charging = false;
      this->time_remaining = 0.0;
      this->temperature = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _voltage_type =
    double;
  _voltage_type voltage;
  using _current_type =
    double;
  _current_type current;
  using _power_consumption_type =
    double;
  _power_consumption_type power_consumption;
  using _remaining_capacity_type =
    double;
  _remaining_capacity_type remaining_capacity;
  using _relative_remaining_capacity_type =
    double;
  _relative_remaining_capacity_type relative_remaining_capacity;
  using _connected_type =
    bool;
  _connected_type connected;
  using _charging_type =
    bool;
  _charging_type charging;
  using _time_remaining_type =
    double;
  _time_remaining_type time_remaining;
  using _temperature_type =
    double;
  _temperature_type temperature;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__voltage(
    const double & _arg)
  {
    this->voltage = _arg;
    return *this;
  }
  Type & set__current(
    const double & _arg)
  {
    this->current = _arg;
    return *this;
  }
  Type & set__power_consumption(
    const double & _arg)
  {
    this->power_consumption = _arg;
    return *this;
  }
  Type & set__remaining_capacity(
    const double & _arg)
  {
    this->remaining_capacity = _arg;
    return *this;
  }
  Type & set__relative_remaining_capacity(
    const double & _arg)
  {
    this->relative_remaining_capacity = _arg;
    return *this;
  }
  Type & set__connected(
    const bool & _arg)
  {
    this->connected = _arg;
    return *this;
  }
  Type & set__charging(
    const bool & _arg)
  {
    this->charging = _arg;
    return *this;
  }
  Type & set__time_remaining(
    const double & _arg)
  {
    this->time_remaining = _arg;
    return *this;
  }
  Type & set__temperature(
    const double & _arg)
  {
    this->temperature = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::PowerState_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::PowerState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::PowerState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::PowerState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::PowerState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::PowerState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::PowerState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::PowerState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::PowerState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::PowerState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__PowerState
    std::shared_ptr<cob_msgs::msg::PowerState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__PowerState
    std::shared_ptr<cob_msgs::msg::PowerState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PowerState_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->voltage != other.voltage) {
      return false;
    }
    if (this->current != other.current) {
      return false;
    }
    if (this->power_consumption != other.power_consumption) {
      return false;
    }
    if (this->remaining_capacity != other.remaining_capacity) {
      return false;
    }
    if (this->relative_remaining_capacity != other.relative_remaining_capacity) {
      return false;
    }
    if (this->connected != other.connected) {
      return false;
    }
    if (this->charging != other.charging) {
      return false;
    }
    if (this->time_remaining != other.time_remaining) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    return true;
  }
  bool operator!=(const PowerState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PowerState_

// alias to use template instance with default allocator
using PowerState =
  cob_msgs::msg::PowerState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__POWER_STATE__STRUCT_HPP_
