// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/PowerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__POWER_STATE__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__POWER_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/power_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PowerState & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: voltage
  {
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << ", ";
  }

  // member: current
  {
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << ", ";
  }

  // member: power_consumption
  {
    out << "power_consumption: ";
    rosidl_generator_traits::value_to_yaml(msg.power_consumption, out);
    out << ", ";
  }

  // member: remaining_capacity
  {
    out << "remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_capacity, out);
    out << ", ";
  }

  // member: relative_remaining_capacity
  {
    out << "relative_remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.relative_remaining_capacity, out);
    out << ", ";
  }

  // member: connected
  {
    out << "connected: ";
    rosidl_generator_traits::value_to_yaml(msg.connected, out);
    out << ", ";
  }

  // member: charging
  {
    out << "charging: ";
    rosidl_generator_traits::value_to_yaml(msg.charging, out);
    out << ", ";
  }

  // member: time_remaining
  {
    out << "time_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.time_remaining, out);
    out << ", ";
  }

  // member: temperature
  {
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PowerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: voltage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voltage: ";
    rosidl_generator_traits::value_to_yaml(msg.voltage, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    rosidl_generator_traits::value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: power_consumption
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_consumption: ";
    rosidl_generator_traits::value_to_yaml(msg.power_consumption, out);
    out << "\n";
  }

  // member: remaining_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.remaining_capacity, out);
    out << "\n";
  }

  // member: relative_remaining_capacity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relative_remaining_capacity: ";
    rosidl_generator_traits::value_to_yaml(msg.relative_remaining_capacity, out);
    out << "\n";
  }

  // member: connected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connected: ";
    rosidl_generator_traits::value_to_yaml(msg.connected, out);
    out << "\n";
  }

  // member: charging
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "charging: ";
    rosidl_generator_traits::value_to_yaml(msg.charging, out);
    out << "\n";
  }

  // member: time_remaining
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_remaining: ";
    rosidl_generator_traits::value_to_yaml(msg.time_remaining, out);
    out << "\n";
  }

  // member: temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.temperature, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PowerState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::PowerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::PowerState & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::PowerState>()
{
  return "cob_msgs::msg::PowerState";
}

template<>
inline const char * name<cob_msgs::msg::PowerState>()
{
  return "cob_msgs/msg/PowerState";
}

template<>
struct has_fixed_size<cob_msgs::msg::PowerState>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<cob_msgs::msg::PowerState>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<cob_msgs::msg::PowerState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__POWER_STATE__TRAITS_HPP_
