// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from cob_msgs:msg/SafetyControllerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__BUILDER_HPP_
#define COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "cob_msgs/msg/detail/safety_controller_state__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace cob_msgs
{

namespace msg
{

namespace builder
{

class Init_SafetyControllerState_torso_enabled
{
public:
  explicit Init_SafetyControllerState_torso_enabled(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  ::cob_msgs::msg::SafetyControllerState torso_enabled(::cob_msgs::msg::SafetyControllerState::_torso_enabled_type arg)
  {
    msg_.torso_enabled = std::move(arg);
    return std::move(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_base_enabled
{
public:
  explicit Init_SafetyControllerState_base_enabled(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_torso_enabled base_enabled(::cob_msgs::msg::SafetyControllerState::_base_enabled_type arg)
  {
    msg_.base_enabled = std::move(arg);
    return Init_SafetyControllerState_torso_enabled(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_torso_active
{
public:
  explicit Init_SafetyControllerState_torso_active(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_base_enabled torso_active(::cob_msgs::msg::SafetyControllerState::_torso_active_type arg)
  {
    msg_.torso_active = std::move(arg);
    return Init_SafetyControllerState_base_enabled(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_base_active
{
public:
  explicit Init_SafetyControllerState_base_active(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_torso_active base_active(::cob_msgs::msg::SafetyControllerState::_base_active_type arg)
  {
    msg_.base_active = std::move(arg);
    return Init_SafetyControllerState_torso_active(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_fall_sensor_released
{
public:
  explicit Init_SafetyControllerState_fall_sensor_released(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_base_active fall_sensor_released(::cob_msgs::msg::SafetyControllerState::_fall_sensor_released_type arg)
  {
    msg_.fall_sensor_released = std::move(arg);
    return Init_SafetyControllerState_base_active(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_fall_sensor_right
{
public:
  explicit Init_SafetyControllerState_fall_sensor_right(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_fall_sensor_released fall_sensor_right(::cob_msgs::msg::SafetyControllerState::_fall_sensor_right_type arg)
  {
    msg_.fall_sensor_right = std::move(arg);
    return Init_SafetyControllerState_fall_sensor_released(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_fall_sensor_left
{
public:
  explicit Init_SafetyControllerState_fall_sensor_left(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_fall_sensor_right fall_sensor_left(::cob_msgs::msg::SafetyControllerState::_fall_sensor_left_type arg)
  {
    msg_.fall_sensor_left = std::move(arg);
    return Init_SafetyControllerState_fall_sensor_right(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_fall_sensor_front
{
public:
  explicit Init_SafetyControllerState_fall_sensor_front(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_fall_sensor_left fall_sensor_front(::cob_msgs::msg::SafetyControllerState::_fall_sensor_front_type arg)
  {
    msg_.fall_sensor_front = std::move(arg);
    return Init_SafetyControllerState_fall_sensor_left(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_laser_right_ok
{
public:
  explicit Init_SafetyControllerState_laser_right_ok(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_fall_sensor_front laser_right_ok(::cob_msgs::msg::SafetyControllerState::_laser_right_ok_type arg)
  {
    msg_.laser_right_ok = std::move(arg);
    return Init_SafetyControllerState_fall_sensor_front(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_laser_left_ok
{
public:
  explicit Init_SafetyControllerState_laser_left_ok(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_laser_right_ok laser_left_ok(::cob_msgs::msg::SafetyControllerState::_laser_left_ok_type arg)
  {
    msg_.laser_left_ok = std::move(arg);
    return Init_SafetyControllerState_laser_right_ok(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_laser_front_ok
{
public:
  explicit Init_SafetyControllerState_laser_front_ok(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_laser_left_ok laser_front_ok(::cob_msgs::msg::SafetyControllerState::_laser_front_ok_type arg)
  {
    msg_.laser_front_ok = std::move(arg);
    return Init_SafetyControllerState_laser_left_ok(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_magnetic_safety_switch
{
public:
  explicit Init_SafetyControllerState_magnetic_safety_switch(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_laser_front_ok magnetic_safety_switch(::cob_msgs::msg::SafetyControllerState::_magnetic_safety_switch_type arg)
  {
    msg_.magnetic_safety_switch = std::move(arg);
    return Init_SafetyControllerState_laser_front_ok(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_wireless_bridged
{
public:
  explicit Init_SafetyControllerState_wireless_bridged(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_magnetic_safety_switch wireless_bridged(::cob_msgs::msg::SafetyControllerState::_wireless_bridged_type arg)
  {
    msg_.wireless_bridged = std::move(arg);
    return Init_SafetyControllerState_magnetic_safety_switch(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_laser_bridged
{
public:
  explicit Init_SafetyControllerState_laser_bridged(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_wireless_bridged laser_bridged(::cob_msgs::msg::SafetyControllerState::_laser_bridged_type arg)
  {
    msg_.laser_bridged = std::move(arg);
    return Init_SafetyControllerState_wireless_bridged(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_external_stop
{
public:
  explicit Init_SafetyControllerState_external_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_laser_bridged external_stop(::cob_msgs::msg::SafetyControllerState::_external_stop_type arg)
  {
    msg_.external_stop = std::move(arg);
    return Init_SafetyControllerState_laser_bridged(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_fall_sensor_stop
{
public:
  explicit Init_SafetyControllerState_fall_sensor_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_external_stop fall_sensor_stop(::cob_msgs::msg::SafetyControllerState::_fall_sensor_stop_type arg)
  {
    msg_.fall_sensor_stop = std::move(arg);
    return Init_SafetyControllerState_external_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_wireless_stop
{
public:
  explicit Init_SafetyControllerState_wireless_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_fall_sensor_stop wireless_stop(::cob_msgs::msg::SafetyControllerState::_wireless_stop_type arg)
  {
    msg_.wireless_stop = std::move(arg);
    return Init_SafetyControllerState_fall_sensor_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_laser_stop
{
public:
  explicit Init_SafetyControllerState_laser_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_wireless_stop laser_stop(::cob_msgs::msg::SafetyControllerState::_laser_stop_type arg)
  {
    msg_.laser_stop = std::move(arg);
    return Init_SafetyControllerState_wireless_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_brake_button_stop
{
public:
  explicit Init_SafetyControllerState_brake_button_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_laser_stop brake_button_stop(::cob_msgs::msg::SafetyControllerState::_brake_button_stop_type arg)
  {
    msg_.brake_button_stop = std::move(arg);
    return Init_SafetyControllerState_laser_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_emergency_button_stop
{
public:
  explicit Init_SafetyControllerState_emergency_button_stop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_brake_button_stop emergency_button_stop(::cob_msgs::msg::SafetyControllerState::_emergency_button_stop_type arg)
  {
    msg_.emergency_button_stop = std::move(arg);
    return Init_SafetyControllerState_brake_button_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_ack_needed
{
public:
  explicit Init_SafetyControllerState_ack_needed(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_emergency_button_stop ack_needed(::cob_msgs::msg::SafetyControllerState::_ack_needed_type arg)
  {
    msg_.ack_needed = std::move(arg);
    return Init_SafetyControllerState_emergency_button_stop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_has_magnetic_safety_switch
{
public:
  explicit Init_SafetyControllerState_has_magnetic_safety_switch(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_ack_needed has_magnetic_safety_switch(::cob_msgs::msg::SafetyControllerState::_has_magnetic_safety_switch_type arg)
  {
    msg_.has_magnetic_safety_switch = std::move(arg);
    return Init_SafetyControllerState_ack_needed(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_has_fall_sensors
{
public:
  explicit Init_SafetyControllerState_has_fall_sensors(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_has_magnetic_safety_switch has_fall_sensors(::cob_msgs::msg::SafetyControllerState::_has_fall_sensors_type arg)
  {
    msg_.has_fall_sensors = std::move(arg);
    return Init_SafetyControllerState_has_magnetic_safety_switch(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_has_wireless_emstop
{
public:
  explicit Init_SafetyControllerState_has_wireless_emstop(::cob_msgs::msg::SafetyControllerState & msg)
  : msg_(msg)
  {}
  Init_SafetyControllerState_has_fall_sensors has_wireless_emstop(::cob_msgs::msg::SafetyControllerState::_has_wireless_emstop_type arg)
  {
    msg_.has_wireless_emstop = std::move(arg);
    return Init_SafetyControllerState_has_fall_sensors(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

class Init_SafetyControllerState_header
{
public:
  Init_SafetyControllerState_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SafetyControllerState_has_wireless_emstop header(::cob_msgs::msg::SafetyControllerState::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_SafetyControllerState_has_wireless_emstop(msg_);
  }

private:
  ::cob_msgs::msg::SafetyControllerState msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::cob_msgs::msg::SafetyControllerState>()
{
  return cob_msgs::msg::builder::Init_SafetyControllerState_header();
}

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__BUILDER_HPP_
