// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from cob_msgs:msg/SafetyControllerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__STRUCT_HPP_
#define COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__cob_msgs__msg__SafetyControllerState __attribute__((deprecated))
#else
# define DEPRECATED__cob_msgs__msg__SafetyControllerState __declspec(deprecated)
#endif

namespace cob_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SafetyControllerState_
{
  using Type = SafetyControllerState_<ContainerAllocator>;

  explicit SafetyControllerState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->has_wireless_emstop = false;
      this->has_fall_sensors = false;
      this->has_magnetic_safety_switch = false;
      this->ack_needed = false;
      this->emergency_button_stop = false;
      this->brake_button_stop = false;
      this->laser_stop = false;
      this->wireless_stop = false;
      this->fall_sensor_stop = false;
      this->external_stop = false;
      this->laser_bridged = false;
      this->wireless_bridged = false;
      this->magnetic_safety_switch = false;
      this->laser_front_ok = false;
      this->laser_left_ok = false;
      this->laser_right_ok = false;
      this->fall_sensor_front = false;
      this->fall_sensor_left = false;
      this->fall_sensor_right = false;
      this->fall_sensor_released = false;
      this->base_active = false;
      this->torso_active = false;
      this->base_enabled = false;
      this->torso_enabled = false;
    }
  }

  explicit SafetyControllerState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->has_wireless_emstop = false;
      this->has_fall_sensors = false;
      this->has_magnetic_safety_switch = false;
      this->ack_needed = false;
      this->emergency_button_stop = false;
      this->brake_button_stop = false;
      this->laser_stop = false;
      this->wireless_stop = false;
      this->fall_sensor_stop = false;
      this->external_stop = false;
      this->laser_bridged = false;
      this->wireless_bridged = false;
      this->magnetic_safety_switch = false;
      this->laser_front_ok = false;
      this->laser_left_ok = false;
      this->laser_right_ok = false;
      this->fall_sensor_front = false;
      this->fall_sensor_left = false;
      this->fall_sensor_right = false;
      this->fall_sensor_released = false;
      this->base_active = false;
      this->torso_active = false;
      this->base_enabled = false;
      this->torso_enabled = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _has_wireless_emstop_type =
    bool;
  _has_wireless_emstop_type has_wireless_emstop;
  using _has_fall_sensors_type =
    bool;
  _has_fall_sensors_type has_fall_sensors;
  using _has_magnetic_safety_switch_type =
    bool;
  _has_magnetic_safety_switch_type has_magnetic_safety_switch;
  using _ack_needed_type =
    bool;
  _ack_needed_type ack_needed;
  using _emergency_button_stop_type =
    bool;
  _emergency_button_stop_type emergency_button_stop;
  using _brake_button_stop_type =
    bool;
  _brake_button_stop_type brake_button_stop;
  using _laser_stop_type =
    bool;
  _laser_stop_type laser_stop;
  using _wireless_stop_type =
    bool;
  _wireless_stop_type wireless_stop;
  using _fall_sensor_stop_type =
    bool;
  _fall_sensor_stop_type fall_sensor_stop;
  using _external_stop_type =
    bool;
  _external_stop_type external_stop;
  using _laser_bridged_type =
    bool;
  _laser_bridged_type laser_bridged;
  using _wireless_bridged_type =
    bool;
  _wireless_bridged_type wireless_bridged;
  using _magnetic_safety_switch_type =
    bool;
  _magnetic_safety_switch_type magnetic_safety_switch;
  using _laser_front_ok_type =
    bool;
  _laser_front_ok_type laser_front_ok;
  using _laser_left_ok_type =
    bool;
  _laser_left_ok_type laser_left_ok;
  using _laser_right_ok_type =
    bool;
  _laser_right_ok_type laser_right_ok;
  using _fall_sensor_front_type =
    bool;
  _fall_sensor_front_type fall_sensor_front;
  using _fall_sensor_left_type =
    bool;
  _fall_sensor_left_type fall_sensor_left;
  using _fall_sensor_right_type =
    bool;
  _fall_sensor_right_type fall_sensor_right;
  using _fall_sensor_released_type =
    bool;
  _fall_sensor_released_type fall_sensor_released;
  using _base_active_type =
    bool;
  _base_active_type base_active;
  using _torso_active_type =
    bool;
  _torso_active_type torso_active;
  using _base_enabled_type =
    bool;
  _base_enabled_type base_enabled;
  using _torso_enabled_type =
    bool;
  _torso_enabled_type torso_enabled;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__has_wireless_emstop(
    const bool & _arg)
  {
    this->has_wireless_emstop = _arg;
    return *this;
  }
  Type & set__has_fall_sensors(
    const bool & _arg)
  {
    this->has_fall_sensors = _arg;
    return *this;
  }
  Type & set__has_magnetic_safety_switch(
    const bool & _arg)
  {
    this->has_magnetic_safety_switch = _arg;
    return *this;
  }
  Type & set__ack_needed(
    const bool & _arg)
  {
    this->ack_needed = _arg;
    return *this;
  }
  Type & set__emergency_button_stop(
    const bool & _arg)
  {
    this->emergency_button_stop = _arg;
    return *this;
  }
  Type & set__brake_button_stop(
    const bool & _arg)
  {
    this->brake_button_stop = _arg;
    return *this;
  }
  Type & set__laser_stop(
    const bool & _arg)
  {
    this->laser_stop = _arg;
    return *this;
  }
  Type & set__wireless_stop(
    const bool & _arg)
  {
    this->wireless_stop = _arg;
    return *this;
  }
  Type & set__fall_sensor_stop(
    const bool & _arg)
  {
    this->fall_sensor_stop = _arg;
    return *this;
  }
  Type & set__external_stop(
    const bool & _arg)
  {
    this->external_stop = _arg;
    return *this;
  }
  Type & set__laser_bridged(
    const bool & _arg)
  {
    this->laser_bridged = _arg;
    return *this;
  }
  Type & set__wireless_bridged(
    const bool & _arg)
  {
    this->wireless_bridged = _arg;
    return *this;
  }
  Type & set__magnetic_safety_switch(
    const bool & _arg)
  {
    this->magnetic_safety_switch = _arg;
    return *this;
  }
  Type & set__laser_front_ok(
    const bool & _arg)
  {
    this->laser_front_ok = _arg;
    return *this;
  }
  Type & set__laser_left_ok(
    const bool & _arg)
  {
    this->laser_left_ok = _arg;
    return *this;
  }
  Type & set__laser_right_ok(
    const bool & _arg)
  {
    this->laser_right_ok = _arg;
    return *this;
  }
  Type & set__fall_sensor_front(
    const bool & _arg)
  {
    this->fall_sensor_front = _arg;
    return *this;
  }
  Type & set__fall_sensor_left(
    const bool & _arg)
  {
    this->fall_sensor_left = _arg;
    return *this;
  }
  Type & set__fall_sensor_right(
    const bool & _arg)
  {
    this->fall_sensor_right = _arg;
    return *this;
  }
  Type & set__fall_sensor_released(
    const bool & _arg)
  {
    this->fall_sensor_released = _arg;
    return *this;
  }
  Type & set__base_active(
    const bool & _arg)
  {
    this->base_active = _arg;
    return *this;
  }
  Type & set__torso_active(
    const bool & _arg)
  {
    this->torso_active = _arg;
    return *this;
  }
  Type & set__base_enabled(
    const bool & _arg)
  {
    this->base_enabled = _arg;
    return *this;
  }
  Type & set__torso_enabled(
    const bool & _arg)
  {
    this->torso_enabled = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    cob_msgs::msg::SafetyControllerState_<ContainerAllocator> *;
  using ConstRawPtr =
    const cob_msgs::msg::SafetyControllerState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::SafetyControllerState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      cob_msgs::msg::SafetyControllerState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__cob_msgs__msg__SafetyControllerState
    std::shared_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__cob_msgs__msg__SafetyControllerState
    std::shared_ptr<cob_msgs::msg::SafetyControllerState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SafetyControllerState_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->has_wireless_emstop != other.has_wireless_emstop) {
      return false;
    }
    if (this->has_fall_sensors != other.has_fall_sensors) {
      return false;
    }
    if (this->has_magnetic_safety_switch != other.has_magnetic_safety_switch) {
      return false;
    }
    if (this->ack_needed != other.ack_needed) {
      return false;
    }
    if (this->emergency_button_stop != other.emergency_button_stop) {
      return false;
    }
    if (this->brake_button_stop != other.brake_button_stop) {
      return false;
    }
    if (this->laser_stop != other.laser_stop) {
      return false;
    }
    if (this->wireless_stop != other.wireless_stop) {
      return false;
    }
    if (this->fall_sensor_stop != other.fall_sensor_stop) {
      return false;
    }
    if (this->external_stop != other.external_stop) {
      return false;
    }
    if (this->laser_bridged != other.laser_bridged) {
      return false;
    }
    if (this->wireless_bridged != other.wireless_bridged) {
      return false;
    }
    if (this->magnetic_safety_switch != other.magnetic_safety_switch) {
      return false;
    }
    if (this->laser_front_ok != other.laser_front_ok) {
      return false;
    }
    if (this->laser_left_ok != other.laser_left_ok) {
      return false;
    }
    if (this->laser_right_ok != other.laser_right_ok) {
      return false;
    }
    if (this->fall_sensor_front != other.fall_sensor_front) {
      return false;
    }
    if (this->fall_sensor_left != other.fall_sensor_left) {
      return false;
    }
    if (this->fall_sensor_right != other.fall_sensor_right) {
      return false;
    }
    if (this->fall_sensor_released != other.fall_sensor_released) {
      return false;
    }
    if (this->base_active != other.base_active) {
      return false;
    }
    if (this->torso_active != other.torso_active) {
      return false;
    }
    if (this->base_enabled != other.base_enabled) {
      return false;
    }
    if (this->torso_enabled != other.torso_enabled) {
      return false;
    }
    return true;
  }
  bool operator!=(const SafetyControllerState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SafetyControllerState_

// alias to use template instance with default allocator
using SafetyControllerState =
  cob_msgs::msg::SafetyControllerState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace cob_msgs

#endif  // COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__STRUCT_HPP_
