// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from cob_msgs:msg/SafetyControllerState.idl
// generated code does not contain a copyright notice

#ifndef COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__TRAITS_HPP_
#define COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "cob_msgs/msg/detail/safety_controller_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace cob_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SafetyControllerState & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: has_wireless_emstop
  {
    out << "has_wireless_emstop: ";
    rosidl_generator_traits::value_to_yaml(msg.has_wireless_emstop, out);
    out << ", ";
  }

  // member: has_fall_sensors
  {
    out << "has_fall_sensors: ";
    rosidl_generator_traits::value_to_yaml(msg.has_fall_sensors, out);
    out << ", ";
  }

  // member: has_magnetic_safety_switch
  {
    out << "has_magnetic_safety_switch: ";
    rosidl_generator_traits::value_to_yaml(msg.has_magnetic_safety_switch, out);
    out << ", ";
  }

  // member: ack_needed
  {
    out << "ack_needed: ";
    rosidl_generator_traits::value_to_yaml(msg.ack_needed, out);
    out << ", ";
  }

  // member: emergency_button_stop
  {
    out << "emergency_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_button_stop, out);
    out << ", ";
  }

  // member: brake_button_stop
  {
    out << "brake_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_button_stop, out);
    out << ", ";
  }

  // member: laser_stop
  {
    out << "laser_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_stop, out);
    out << ", ";
  }

  // member: wireless_stop
  {
    out << "wireless_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.wireless_stop, out);
    out << ", ";
  }

  // member: fall_sensor_stop
  {
    out << "fall_sensor_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_stop, out);
    out << ", ";
  }

  // member: external_stop
  {
    out << "external_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.external_stop, out);
    out << ", ";
  }

  // member: laser_bridged
  {
    out << "laser_bridged: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_bridged, out);
    out << ", ";
  }

  // member: wireless_bridged
  {
    out << "wireless_bridged: ";
    rosidl_generator_traits::value_to_yaml(msg.wireless_bridged, out);
    out << ", ";
  }

  // member: magnetic_safety_switch
  {
    out << "magnetic_safety_switch: ";
    rosidl_generator_traits::value_to_yaml(msg.magnetic_safety_switch, out);
    out << ", ";
  }

  // member: laser_front_ok
  {
    out << "laser_front_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_front_ok, out);
    out << ", ";
  }

  // member: laser_left_ok
  {
    out << "laser_left_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_left_ok, out);
    out << ", ";
  }

  // member: laser_right_ok
  {
    out << "laser_right_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_right_ok, out);
    out << ", ";
  }

  // member: fall_sensor_front
  {
    out << "fall_sensor_front: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_front, out);
    out << ", ";
  }

  // member: fall_sensor_left
  {
    out << "fall_sensor_left: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_left, out);
    out << ", ";
  }

  // member: fall_sensor_right
  {
    out << "fall_sensor_right: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_right, out);
    out << ", ";
  }

  // member: fall_sensor_released
  {
    out << "fall_sensor_released: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_released, out);
    out << ", ";
  }

  // member: base_active
  {
    out << "base_active: ";
    rosidl_generator_traits::value_to_yaml(msg.base_active, out);
    out << ", ";
  }

  // member: torso_active
  {
    out << "torso_active: ";
    rosidl_generator_traits::value_to_yaml(msg.torso_active, out);
    out << ", ";
  }

  // member: base_enabled
  {
    out << "base_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.base_enabled, out);
    out << ", ";
  }

  // member: torso_enabled
  {
    out << "torso_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.torso_enabled, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SafetyControllerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: has_wireless_emstop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_wireless_emstop: ";
    rosidl_generator_traits::value_to_yaml(msg.has_wireless_emstop, out);
    out << "\n";
  }

  // member: has_fall_sensors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_fall_sensors: ";
    rosidl_generator_traits::value_to_yaml(msg.has_fall_sensors, out);
    out << "\n";
  }

  // member: has_magnetic_safety_switch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "has_magnetic_safety_switch: ";
    rosidl_generator_traits::value_to_yaml(msg.has_magnetic_safety_switch, out);
    out << "\n";
  }

  // member: ack_needed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ack_needed: ";
    rosidl_generator_traits::value_to_yaml(msg.ack_needed, out);
    out << "\n";
  }

  // member: emergency_button_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "emergency_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.emergency_button_stop, out);
    out << "\n";
  }

  // member: brake_button_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake_button_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.brake_button_stop, out);
    out << "\n";
  }

  // member: laser_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_stop, out);
    out << "\n";
  }

  // member: wireless_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wireless_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.wireless_stop, out);
    out << "\n";
  }

  // member: fall_sensor_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_sensor_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_stop, out);
    out << "\n";
  }

  // member: external_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "external_stop: ";
    rosidl_generator_traits::value_to_yaml(msg.external_stop, out);
    out << "\n";
  }

  // member: laser_bridged
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_bridged: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_bridged, out);
    out << "\n";
  }

  // member: wireless_bridged
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wireless_bridged: ";
    rosidl_generator_traits::value_to_yaml(msg.wireless_bridged, out);
    out << "\n";
  }

  // member: magnetic_safety_switch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "magnetic_safety_switch: ";
    rosidl_generator_traits::value_to_yaml(msg.magnetic_safety_switch, out);
    out << "\n";
  }

  // member: laser_front_ok
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_front_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_front_ok, out);
    out << "\n";
  }

  // member: laser_left_ok
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_left_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_left_ok, out);
    out << "\n";
  }

  // member: laser_right_ok
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "laser_right_ok: ";
    rosidl_generator_traits::value_to_yaml(msg.laser_right_ok, out);
    out << "\n";
  }

  // member: fall_sensor_front
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_sensor_front: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_front, out);
    out << "\n";
  }

  // member: fall_sensor_left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_sensor_left: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_left, out);
    out << "\n";
  }

  // member: fall_sensor_right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_sensor_right: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_right, out);
    out << "\n";
  }

  // member: fall_sensor_released
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fall_sensor_released: ";
    rosidl_generator_traits::value_to_yaml(msg.fall_sensor_released, out);
    out << "\n";
  }

  // member: base_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_active: ";
    rosidl_generator_traits::value_to_yaml(msg.base_active, out);
    out << "\n";
  }

  // member: torso_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "torso_active: ";
    rosidl_generator_traits::value_to_yaml(msg.torso_active, out);
    out << "\n";
  }

  // member: base_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.base_enabled, out);
    out << "\n";
  }

  // member: torso_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "torso_enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.torso_enabled, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SafetyControllerState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace cob_msgs

namespace rosidl_generator_traits
{

[[deprecated("use cob_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const cob_msgs::msg::SafetyControllerState & msg,
  std::ostream & out, size_t indentation = 0)
{
  cob_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use cob_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const cob_msgs::msg::SafetyControllerState & msg)
{
  return cob_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<cob_msgs::msg::SafetyControllerState>()
{
  return "cob_msgs::msg::SafetyControllerState";
}

template<>
inline const char * name<cob_msgs::msg::SafetyControllerState>()
{
  return "cob_msgs/msg/SafetyControllerState";
}

template<>
struct has_fixed_size<cob_msgs::msg::SafetyControllerState>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<cob_msgs::msg::SafetyControllerState>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<cob_msgs::msg::SafetyControllerState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // COB_MSGS__MSG__DETAIL__SAFETY_CONTROLLER_STATE__TRAITS_HPP_
